# frozen_string_literal: true

RSpec.describe GitlabQuality::TestTooling::Report::MergeRequestSlowTestsReport do
  describe '#invoke!' do
    context 'when there are slow tests found' do
      let(:files_with_slow_test) do
        [
          File.expand_path("fixtures/rspec-reports/mr-related-slow-tests-1.json", __dir__),
          File.expand_path("fixtures/rspec-reports/mr-related-slow-tests-2.json", __dir__)
        ]
      end

      let(:project) { 'valid-project' }
      let(:merge_request_class) { Struct.new(:iid, :web_url, :state, :title, :description, :labels) }
      let(:merge_request) { merge_request_class.new(10, 'http://new-merge_request.url/0') }
      let(:merge_request_rspec_files) { ['ee/spec/requests/api/visual_review_discussions_spec.rb'] }
      let(:test_name) do
        'API::VisualReviewDiscussions when project is public behaves like accepting request without authentication behaves like handling merge request feedback creates a new note'
      end

      let(:note_class) { Struct.new(:id, :body) }
      let(:report) { described_class.new(token: 'token', input_files: files_with_slow_test, merge_request_iid: merge_request.iid, project: project) }

      let(:mr_note) do
        <<~NOTE.chomp
          <!-- slow-test -->
          /label ~"rspec:slow test detected"
          :tools: Generated by [`gitlab_quality-test_tooling`](https://gitlab.com/gitlab-org/ruby/gems/gitlab_quality-test_tooling/-/blob/main/lib/gitlab_quality/test_tooling/report/merge_request_slow_tests_report.rb).

          ---

          :snail: Slow tests detected in this merge request. These slow tests might be related to this merge request's changes.
          <details><summary>Click to expand</summary>

          | Job | File | Name | Duration | Expected duration |
          | --- | --- | --- | --- | --- |
          | [#4509805924](https://gitlab.com/gitlab-org/gitlab/-/jobs/4509805924) | [`ee/spec/requests/api/visual_review_discussions_spec.rb#L177`](https://gitlab.com/#{project}/-/blob/master/ee/spec/requests/api/visual_review_discussions_spec.rb#L177) | API::VisualReviewDiscussions when project is public behaves like accepting request without authentication behaves like handling merge request feedback creates a new note | 28.98 s | < 19.2 s |
          | [#4509805925](https://gitlab.com/gitlab-org/gitlab/-/jobs/4509805925) | [`ee/spec/requests/api/visual_review_discussions_spec.rb#L177`](https://gitlab.com/#{project}/-/blob/master/ee/spec/requests/api/visual_review_discussions_spec.rb#L177) | API::VisualReviewDiscussions when project is public behaves like accepting request without authentication behaves like handling merge request feedback creates a new note | 28.98 s | < 19.2 s |

          </details>
        NOTE
      end

      around do |example|
        ClimateControl.modify(CI_COMMIT_REF_NAME: 'master') do
          example.run
        end
      end

      context 'with slow test introduced' do
        context 'without existing note' do
          let(:new_note) { note_class.new(0, mr_note) }

          before do
            allow(report.__send__(:gitlab_merge_request)).to receive(:merge_request_changed_files)
                                                               .and_return(merge_request_rspec_files)
            allow(report.__send__(:gitlab_merge_request)).to receive(:find_note)
                                                               .with(body: described_class::SLOW_TEST_MESSAGE, merge_request_iid: merge_request.iid)
                                                               .and_return(nil)
          end

          it 'adds a slow test merge request note' do
            expect(report.__send__(:gitlab_merge_request)).to receive(:create_note)
                                                                .with(note: mr_note, merge_request_iid: merge_request.iid)
                                                                .and_return(new_note)

            expect { report.invoke! }
              .to output(/.*Create note for merge request: 10/).to_stdout
          end

          it 'does not include failed examples' do
            expect(report.__send__(:gitlab_merge_request)).to receive(:create_note)
                                                                .with(note: mr_note, merge_request_iid: merge_request.iid)
                                                                .and_return(new_note)

            expect { report.invoke! }
              .to output(/.*Create note for merge request: 10/).to_stdout

            expect(report.__send__(:slow_tests).select(&:failed?)).to be_empty
          end
        end

        context 'with existing note' do
          let(:existing_mr_note) do
            <<~NOTE.chomp
              <!-- slow-test -->
              /label ~"rspec:slow test detected"
              :tools: Generated by [`gitlab_quality-test_tooling`](https://gitlab.com/gitlab-org/ruby/gems/gitlab_quality-test_tooling/-/blob/main/lib/gitlab_quality/test_tooling/report/merge_request_slow_tests_report.rb).

              ---

              :snail: Slow tests detected in this merge request. These slow tests might be related to this merge request's changes.
              <details><summary>Click to expand</summary>

              | Job | File | Name | Duration | Expected duration |
              | --- | --- | --- | --- | --- |
              | [#4509805924](https://gitlab.com/gitlab-org/gitlab/-/jobs/4509805924) | [`ee/spec/requests/api/visual_review_discussions_spec.rb#L177`](https://gitlab.com/#{project}/-/blob/master/ee/spec/requests/api/visual_review_discussions_spec.rb#L177) | API::VisualReviewDiscussions when project is public behaves like accepting request without authentication behaves like handling merge request feedback creates a new note | 28.98 s | < 19.2 s |

              </details>
            NOTE
          end

          let(:existing_note) { note_class.new(1, existing_mr_note) }
          let(:updated_note) { note_class.new(1, mr_note) }

          before do
            allow(report.__send__(:gitlab_merge_request)).to receive(:merge_request_changed_files)
                                                               .and_return(merge_request_rspec_files)
            allow(report.__send__(:gitlab_merge_request)).to receive(:find_note)
                                                               .with(body: described_class::SLOW_TEST_MESSAGE, merge_request_iid: merge_request.iid)
                                                               .and_return(existing_note)
          end

          it 'updates existing slow test merge request note' do
            expect(report.__send__(:gitlab_merge_request)).to receive(:update_note)
                                                                .with(id: 1, note: mr_note, merge_request_iid: merge_request.iid)
                                                                .and_return(updated_note)

            expect { report.invoke! }
              .to output(/Update note for merge request: 10/).to_stdout
          end
        end
      end

      context 'with no RSpec tests changes' do
        before do
          allow(report.__send__(:gitlab_merge_request)).to receive(:merge_request_changed_files)
                                                             .and_return([])
        end

        it 'does not create any note' do
          expect(report.__send__(:gitlab_merge_request)).not_to receive(:create_note)
          expect(report.__send__(:gitlab_merge_request)).not_to receive(:update_note)

          expect { report.invoke! }
            .not_to output(/.*Create note for merge request: 10/).to_stdout
        end
      end

      context 'with no slow tests' do
        let(:file_with_no_slow_test) { File.expand_path("fixtures/rspec-reports/rspec-no-slow-tests.json", __dir__) }
        let(:report) { described_class.new(token: 'token', input_files: [file_with_no_slow_test], merge_request_iid: merge_request.iid, project: project) }

        before do
          allow(report.__send__(:gitlab_merge_request)).to receive(:merge_request_changed_files)
                                                             .and_return(merge_request_rspec_files)
        end

        it 'does not create any note' do
          expect(report.__send__(:gitlab_merge_request)).not_to receive(:create_note)
          expect(report.__send__(:gitlab_merge_request)).not_to receive(:update_note)

          expect { report.invoke! }
            .not_to output(/.*Create note for merge request: 10/).to_stdout
        end
      end

      context 'with no slow tests related with MR changes' do
        let(:merge_request_rspec_unrelated_changed_files) { ['ee/spec/requests/api/unrelated_spec.rb'] }

        before do
          allow(report.__send__(:gitlab_merge_request)).to receive(:merge_request_changed_files)
                                                             .and_return(merge_request_rspec_unrelated_changed_files)
          allow(report.__send__(:gitlab_merge_request)).to receive(:find_note)
                                                             .with(body: described_class::SLOW_TEST_MESSAGE, merge_request_iid: merge_request.iid)
                                                             .and_return(nil)
        end

        it 'does not create any note' do
          expect(report.__send__(:gitlab_merge_request)).not_to receive(:create_note)
          expect(report.__send__(:gitlab_merge_request)).not_to receive(:update_note)

          expect { report.invoke! }
            .not_to output(/.*Create note for merge request: 10/).to_stdout
        end
      end
    end
  end
end
